#include <Stepper_28BYJ.h>
#define STEPS 4078

unsigned long F = 36000;
int N = 20;
unsigned long t = ((1/F)*1000000/2);
unsigned long Tp = (N*(t*2));

int led  = 13;

int tsop = A4;
int irledr = A2;
int irledl = A3;
int irledb = A5;

int motl1  = 5;
int motl2  = 4;
int motl3  = 3;
int motl4  = 2;

int motr1  = 9;
int motr2  = 8;
int motr3  = 7;
int motr4  = 6;

int mspeed = 9;
int msteps = 1;

int tsopState;
int btn1State;
int btn2State;

int chb = 0;
int chr = 0;
int chl = 0;

Stepper_28BYJ stepperr(STEPS, motr1, motr2, motr3, motr4);
Stepper_28BYJ stepperl(STEPS, motl1, motl2, motl3, motl4);


void setup() {    
  delay(100);
  pinMode(led, OUTPUT);
  digitalWrite(led, HIGH);delay(100);digitalWrite(led, LOW);delay(100);digitalWrite(led, HIGH);delay(100);digitalWrite(led, LOW);delay(100);digitalWrite(led, HIGH);delay(100);digitalWrite(led, LOW);delay(100);
  
  delay(500);   
  
  pinMode(btn1, INPUT);
  pinMode(btn2, INPUT);
  pinMode(tsop, INPUT);
}

int IRsendq(int irled, int freq){
  tone(irled, freq);
  delayMicroseconds(Tp);
  noTone(irled);
  pinMode(irled, OUTPUT);digitalWrite(irled, HIGH);//
  delayMicroseconds(Tp);
} 

int mv_forward(int steps){
  for(int i=0;i<steps;i++)
    {          
    stepperl.step(-msteps);
    stepperr.step(msteps);
    }
}

int mv_buck(int steps){
  for(int i=0;i<steps;i++)
    {          
    stepperl.step(msteps); 
    stepperr.step(-msteps); 
    }
}

int mv_rotate_l(int steps){
  for(int i=0;i<steps;i++)
    {          
    stepperl.step(msteps); 
    stepperr.step(msteps); 
    }
}

int mv_rotate_r(int steps){
  for(int i=0;i<steps;i++)
    {          
    stepperl.step(-msteps); 
    stepperr.step(-msteps); 
    }
}

int mv_l(int steps){
  for(int i=0;i<steps;i++)
    {          
    stepperl.step(msteps); 
    }
}

int mv_r(int steps){
  for(int i=0;i<steps;i++)
    {           
    stepperr.step(-msteps); 
    }
}

int mot_init(){
  stepperl.setSpeed(mspeed);
  stepperr.setSpeed(mspeed); 
}

int off_motr(){
  digitalWrite(motr1, LOW);digitalWrite(motr2, LOW);digitalWrite(motr3, LOW); digitalWrite(motr4, LOW); 
}

int off_motl(){
  digitalWrite(motl1, LOW);digitalWrite(motl2, LOW);digitalWrite(motl3, LOW); digitalWrite(motl4, LOW); 
}


int check(int irled){
  int ansver = 0;
  tone(irled, F);
  delayMicroseconds(Tp);
  if(digitalRead(tsop) == LOW){ansver=1;}else{ansver=0;}
  noTone(irled);
  pinMode(irled, OUTPUT);digitalWrite(irled, HIGH);//
  delayMicroseconds(Tp);
  return ansver;
}


void loop() {
  mot_init();
  
  chb=check(irledb);
  chr=check(irledr);
  chl=check(irledl);
  
  if(chb==1)
    {
    if(chr==0 && chl==0){mv_forward(500);}
    else if(chr==1 && chl==1){digitalWrite(led, HIGH);mv_buck(1500);mv_rotate_r(1500);}
    else if(chr==1){digitalWrite(led, HIGH);mv_rotate_r(500);}
    else if(chl==1){digitalWrite(led, HIGH);mv_rotate_l(500);}
    }
  else{digitalWrite(led, HIGH);mv_buck(1500);mv_rotate_l(1500);}
  
  digitalWrite(led, LOW);

  off_motr();off_motl();

}
